/* Audio Library for Teensy 3.X
 * Copyright (c) 2014, Paul Stoffregen, paul@pjrc.com
 *
 * Development of this audio library was funded by PJRC.COM, LLC by sales of
 * Teensy and Audio Adaptor boards.  Please support PJRC's efforts to develop
 * open source software by purchasing Teensy or other PJRC products.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice, development funding notice, and this permission
 * notice shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "analyze_transfer.h"
#include "sqrt_integer.h"
#include "utility/dspinst.h"


    const float MAX_INT = 32678.0;
 
void AudioAnalyzeTransfer::update(void)
{
	audio_block_t *blocka,*blockb;
	int16_t *pa, *pb, *end;
	int16_t a12;
	int16_t b12;

	blocka = receiveReadOnly(0);
	blockb = receiveReadOnly(1);
	if (!blocka||count==0) {
		if (blockb) release(blockb);
		if (blocka) release(blocka);
		return;
	}
	if (!blockb) {
		release(blocka);
		return;
	}
	pa = (int16_t *)(blocka->data);
	pb = (int16_t *)(blockb->data);
	end = pa + AUDIO_BLOCK_SAMPLES;
	while (pa < end ) {
		a12 = *pa++;
		b12 = *pb++;
 		int csa = a12>>count;
 		float csb = (float)b12;
//		csa=csa/MAX_INT;
		csb=csb/MAX_INT;
//       if(m_min>a12)
//			m_min=a12;
//        if(m_max<a12)
//			m_max=a12;
	if(csa+offs >=0 && csa+offs<=limit)
		{
			m_arra[csa+offs]=csb;
//			m_arrb[pos++]=csb;
		}
	}
	if (blockb) release(blockb);
	if (blocka) release(blocka);

}


